package main

import (
	"fmt"
	"time"
)

func main() {
	var intChan chan int = make(chan int, 2)

	// 只读 chan
	go func(intChan <-chan int) {
		fmt.Println(<-intChan)
	}(intChan)

	// 只写 chan
	go func(intChan chan<- int) {
		intChan <- 2
	}(intChan)

	// 使用 sleep 等待前面的结束
	time.Sleep(1 * time.Second)

	// 只读 chan
	var rChan <-chan int = intChan
	// 只写 chan
	var wChan chan<- int = intChan

	wChan <- 8
	fmt.Println(<-rChan)

	// Output:
	//2
	//8
}
